; Defined by user elsewhere
; =========================

.import _nsf_init
.import _nsf_play

; NSF header
; ===========

.segment "HEADER_TOP"
.byte 'N', 'E', 'S', 'M', $1A ; ID
.byte $01 ; version
.byte 1 ; songs
.byte 1 ; starting song
.word $8000 ; load address
.word nsfmain   ; init function
.word _nsf_play ; play function
; title
.segment "HEADER_TITLE"
.byte "Giant Steps"
; artist
.segment "HEADER_ARTIST"
.byte "bradsmith / John Coltrane"
; copyright
.segment "HEADER_COPYRIGHT"
.byte "2012 / 1960 - rainwarrior.ca"
; other
.segment "HEADER_OTHER"
.word 16640 ; NTSC speed
.byte 0,0,0,0,0,0,0,0 ; bankswitch init
.word 20000 ; PAL speed
.byte %00000000 ; PAL/NTSC bits
.byte %00000000 ; expansion bits
.byte 0,0,0,0 ; pad to $80

; Generic static variables to avoid stack in C
; ============================================

.export _i, _j, _k, _l, _a, _b;

.segment "ZEROPAGE"
_i: .res 1
_j: .res 1
_k: .res 2
_l: .res 2
_a: .res 1
_b: .res 1

; Reset and startup
; =================

.export vector_reset ; not used, for compatibility with NES crt0

.segment "ASM"

.import crt0_start

vector_reset:
nsfmain:
    ; store A/X temporarily
    pha
    txa
    pha
    ; setup CRT
    jsr crt0_start
    ; call _nsf_init
    pla
    tax
    pla
    jmp _nsf_init

; end of file